
;MB.LSP  Make Block  9-8-94
;Terry Priest   11428 Denzer Road   Evansville, IN  47712

;Autocad Autolisp

;Here is a replacement for the block command.
;First of all it inserts the new block on the screen in the same
;place where it disappeared. Next it allows you to immediately
;write the block to disk, with or without making a slide. You can name
;your block with more than 8 letters, and it gives you the option
;of truncating or renaming the disk file. You can pick the target
;directory from your menu (make a menu screen of your block dirs
;called **dirs using the standard menu foreslash). The last dir used
;is default.

;This is a rewrite of Cadalyst Magazine tip #401 by Laszlo Somogyi April '89,
;which was called Create.Lsp.  The originally simple and elegant program
;is improved to more closely mimic the Block and Wblock commands and give
;user options. I have used it more than any other Cadalyst tip and know others
;have as well. I want to thank Laszlo Somogyi and Cadalyst.
;I hope it proves useful.

;Released into public domain. You have permission to freely use, copy,
;modify, improve, incorporate, sell or pass off as your own work. <g>
;This is not a professional routine. It has been used on versions up
;to R12 in the USA on a limited number of machines.

;check out VSLD.ZIP on CIS for other block/file library routines.

(defun c:mb (/ blname inspt selobj x newnam temp)
  (command "LAYER" "S" "0" "")  ;in general I insert on layer 0
  (setq  blname (getstring "\nBlock name: ")
         x (tblsearch "BLOCK" blname))

  (if x  (progn
     (initget "Yes No")
     (prompt (strcat "\nBlock " (strcase blname) " already exists.\n"))
     (setq x (getkword "Redefine it? <N>"))
     (if (not x) (setq x "No"))))

  (if (or (= x "Yes" ) (not x)) ;does not exist or Yes to redefine
     (progn
        (setq inspt (getpoint "\nInsertion point: ")
              selobj (ssget))
        (if (not x)    ;block does not already exist
           (command "BLOCK" blname inspt selobj "")
           (command "BLOCK" blname x inspt selobj ""))
        (command "INSERT" blname inspt "1" "1" "0")

                (menucmd "S=DIRS")
                    ; you can pick the target dir from your menu

        (prompt "\nAbout to write to file, Type X to eXit ")
        (if (= path nil) (setq path ""))
        (if (and
          (setq temp (getstring (strcat "\nPATH< " path " >: ")))
          (/= temp "") (/= (strcase temp) "X"))
            (setq path (pslash temp)))
        (if (/= (strcase temp) "X")
          (progn
             (setq newnam (trunc8 blname))
             (if (not (findfile (strcat path newnam ".DWG")))
               (progn
                 (command "WBLOCK" (strcat path newnam) blname)
                 (initget "Yes No")
                 (setq x (getkword "Make Slide? <Y>"))
                 (if (not x) (setq x "Yes"))
                 (if (= x "Yes")  (command "MSLIDE" (strcat path newnam))))
               (progn      (initget "Yes No")
                 (prompt "\nA drawing with this name already exists.\n")
                 (setq x (getkword "Do you want to replace it? <Y>"))
                 (if (not x) (setq x "Yes"))
                 (if (= x "Yes")
                    (progn
                      (command "WBLOCK" (strcat path newnam)  "Y" blname)
                      (initget "Yes No")
                      (setq x (getkword "Make Slide? <Y>"))
                      (if (not x) (setq x "Yes"))
                      (if (= x "Yes")
                      (command "MSLIDE" (strcat path newnam)))))))))))) ;12RH

;Subr to truncate block names to 8 letters, returns trunc or renamed name
(defun trunc8 (blk / newblk)
 (if (> (strlen blk) 8) (progn
   (prompt (strcat "\nSorry " blk  " too long. Rename or <T>runcate? "))
   (initget "R T")
   (if (= (getkword) "R")                         ;recursive function does not
         (setq newblk (trunc8 (getstring "New name ")))  ;allow > 8 characters
         (setq newblk (substr blk 1 8)))) ; progn
   (setq newblk blk))) ;else if not > 8

;Slash operator subroutine - changes menu foreslash to dos backslash
;pslash is from "Maximizing (Inside) Autolisp" by Smith & Gesner
;A great book - New Riders Publishing
(defun pslash (path / slash wpath char)
 (setq inc 1  wpath ""  slash "\\")
 (while (/= "" (setq char (substr path inc 1)))
            (setq wpath
               (strcat wpath (if (member char '("\\" "/")) slash char))
               inc (1+ inc)) )
 (if (and (/= wpath "") (/= (substr wpath (strlen wpath) 1) slash))
         (setq wpath (strcat wpath slash)) )
 wpath)

